## ardour 4.7~dfsg

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys
import platform as PLATFORM
from waflib.Tools import winres
from waflib.Build import Context
from waflib.Build import BuildContext

class i18n(BuildContext):
        cmd = 'i18n'
        fun = 'i18n'

class i18n_pot(BuildContext):
        cmd = 'i18n_pot'
        fun = 'i18n_pot'

class i18n_po(BuildContext):
        cmd = 'i18n_po'
        fun = 'i18n_po'

class i18n_mo(BuildContext):
        cmd = 'i18n_mo'
        fun = 'i18n_mo'

def is_tracks_build(self, *k, **kw):
        return self.env['PROGRAM_NAME'] == 'Tracks Live'

Context.Context.is_tracks_build = is_tracks_build

compiler_flags_dictionaries= {
    'gcc' : {
        # Flags required when building a debug build
        'debuggable' : [ '-g' ],
        # Flags required for the linker (if any) when building a debug build
        'linker-debuggable' : '',
        # Flags required when building a non-debug optimized build
        'nondebuggable' : '-DNDEBUG',
        # Flags required to enable profiling at runtime with optimized builds
        'profile' : [ '-fno-omit-frame-pointer' ],
        # Flags required to enable gprofile profiling
        'gprofile' : '-pg',
        # Flags required to disable warnings about unused arguments to function calls
        'silence-unused-arguments' : '',
        # Flags required to use SSE unit for general math
        'sse' : '-msse',
        # Flags required to use SSE unit for floating point math
        'fpmath-sse' : '-mfpmath=sse',
        # Flags required to use XMM Intrinsics
        'xmmintrinsics' : '-DUSE_XMMINTRIN',
        # Flags to use posix pipes between compiler stages
        'pipe' : '-pipe',
        # Flags for maximally optimized build
        'full-optimization' : [ '-O3', '-fomit-frame-pointer', '-ffast-math', '-fstrength-reduce', ],
        # Flag to ensure that compiler error output includes column/line numbers
        'show-column' : '-fshow-column',
        # Flags required to build for x86 only (OS X feature)
        'generic-x86' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-ppc' : '',
        # All flags required to get basic warnings to be generated by the compiler
        'basic-warnings' : [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter' ],
        # Any additional flags for warnings that are specific to C (not C++)
        'extra-c-warnings' : [ '-Wstrict-prototypes', '-Wmissing-prototypes' ],
        # Any additional flags for warnings that are specific to C++ (not C)
        'extra-cxx-warnings' : [ '-Woverloaded-virtual', '-Wno-unused-local-typedefs' ],
        # Flags used for "strict" compilation, C and C++ (i.e. compiler will warn about language issues)
        'strict' : ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings', '-Wunsafe-loop-optimizations', '-Wlogical-op' ],
        # Flags used for "strict" compilation, C only (i.e. compiler will warn about language issues)
        'c-strict' : ['-std=c99', '-pedantic', '-Wshadow'],
        # Flags used for "strict" compilation, C++ only (i.e. compiler will warn about language issues)
        'cxx-strict' : [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ],
        # Flags required for whatever consider the strictest possible compilation
        'ultra-strict' : ['-Wredundant-decls', '-Wstrict-prototypes', '-Wmissing-prototypes'],
        # Flag to turn on C99 compliance by itself
        'c99': '-std=c99',
        # Flag to enable AT&T assembler syntax
        'attasm': '-masm=att',
        # Flags to make AVX instructions/intrinsics available
        'avx': '-mavx',
        # Flags to generate position independent code, when needed to build a shared object
        'pic': '-fPIC',
        # Flags required to compile C code with anonymous unions (only part of C11)
        'c-anonymous-union': '-fms-extensions',
    },
    'msvc' : {
        'debuggable' : ['/DDEBUG', '/Od', '/Zi', '/MDd', '/Gd', '/EHsc'],
        'linker-debuggable' : ['/DEBUG', '/INCREMENTAL' ],
        'nondebuggable' : ['/DNDEBUG', '/Ob1', '/MD', '/Gd', '/EHsc'],
        'profile' : '/Oy-',
        'sse' : '/arch:SSE',
        'silence-unused-arguments' : '',
        'sse' : '',
        'fpmath-sse' : '',
        'xmmintrinsics' : '',
        'pipe' : '',
        'full-optimization' : '/O2',
        'no-frame-pointer' : '',
        'fast-math' : '',
        'strength-reduce' : '',
        'show-column' : '',
        'generic-x86' : '',
        'generic-ppc' : '',
        'basic-warnings' : '',
        'extra-c-warnings' : '',
        'extra-cxx-warnings' : '',
        'ultra-strict' : '',
        'c-strict' : '',
        'cxx-strict' : '',
        'strict' : '',
        'c99': '/TP',
        'attasm': '',
        'avx': '',
        'pic': '',
        'c-anonymous-union': '',
    },
}

# Copy, edit and insert variants on gcc dict for gcc-darwin and clang

gcc_darwin_dict = compiler_flags_dictionaries['gcc'].copy()
gcc_darwin_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual' ]
gcc_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual' ]
gcc_darwin_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
gcc_darwin_dict['generic-x86'] = [ '-arch', 'i386' ]
gcc_darwin_dict['generic-ppc'] = [ '-arch', 'ppc' ]
compiler_flags_dictionaries['gcc-darwin'] = gcc_darwin_dict;

clang_dict = compiler_flags_dictionaries['gcc'].copy();
clang_dict['sse'] = ''
clang_dict['fpmath-sse'] = ''
clang_dict['xmmintrinsics'] = ''
clang_dict['silence-unused-arguments'] = '-Qunused-arguments'
clang_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual', '-Wno-mismatched-tags' ]
clang_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ]
clang_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
clang_dict['generic-x86'] = [ '-arch', 'i386' ]
compiler_flags_dictionaries['clang'] = clang_dict;

clang_darwin_dict = compiler_flags_dictionaries['clang'].copy();
clang_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', ]
clang_darwin_dict['full-optimization'] = [ '-O3', '-ffast-math', '-fstrength-reduce' ]
compiler_flags_dictionaries['clang-darwin'] = clang_darwin_dict;

def fetch_git_revision ():
    cmd = "git describe HEAD | sed 's/^[A-Za-z]*+//'"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode ('utf-8')
    return rev

def fetch_tarball_revision ():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print ('This tarball was not created correctly - it is missing libs/ardour/revision.cc')
        sys.exit (1)
    with open('libs/ardour/revision.cc') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')
        return content[1].decode('utf-8').strip().split(' ')[7].translate (remove_punctuation_map)

if os.path.isdir (os.path.join(os.getcwd(), '.git')):
    rev = fetch_git_revision ()
else:
    rev = fetch_tarball_revision ()

#
# rev is now of the form MAJOR.MINOR[-rcX]-rev-commit
# or, if right at the same rev as a release, MAJOR.MINOR[-rcX]
#

parts = rev.split ('.', 1)
MAJOR = parts[0]
other = parts[1].split('-', 1)
MINOR = other[0]
if len(other) > 1:
    MICRO = other[1].rsplit('-',1)[0].replace('-','.')
else:
    MICRO = '0'

V = MAJOR + '.' + MINOR + '.' + MICRO
# Ensure that these are not unicode, which
# can cause odd problems elsewhere. Note that
# in python3, encode and decode do not return
# strings, so we have to force the type.
VERSION = V.encode ('ascii', 'ignore').decode ("utf-8")
PROGRAM_VERSION = MAJOR.encode ('ascii', 'ignore').decode ("utf-8")

if len (sys.argv) > 1 and sys.argv[1] == 'dist':
        if not 'APPNAME' in os.environ:
                print ("You must define APPNAME in the environment when running ./waf dist")
                sys.exit (1)
        APPNAME = os.environ['APPNAME'];

# Mandatory variables
top = '.'
out = 'build'

children = [
        # optionally external libraries
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/libltc',
        'libs/ptformat',
        # core ardour libraries
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/surfaces',
        'libs/panners',
        'libs/backends',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/audiographer',
        'libs/canvas',
        'libs/plugins/reasonablesynth.lv2',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'patchfiles',
        'headless',
        'session_utils',
        # shared helper binaries (plugin-scanner, exec-wrapper)
        'libs/fst',
        'libs/vfork',
        'libs/ardouralsautil',
        'cfgtool',
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

# Version stuff

def fetch_gcc_version (CC):
    cmd = "%s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("Git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        #
        # if you change the format of this, be sure to fix fetch_tarball_revision() above
        # so that  it still works.
        #
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #
    build_host_supports_sse = False

    # Flags necessary for building
    compiler_flags = []     # generic
    c_flags = []            # C-specific
    cxx_flags = []          # C++-specific
    linker_flags = []

    # Optimization flags (overridable)
    optimization_flags = []

    # Debugging flags
    debug_flags = []

    u = PLATFORM.uname ()
    cpu = u[4]
    platform = u[0].lower()
    version = u[2]

    # waf adds -O0 -g itself. thanks waf!
    is_clang = conf.check_cxx(fragment = '''
#ifndef __clang__
#error
#endif
int main() { return 0; }''',
                         features  = 'cxx',
                         mandatory = False,
                         execute   = False,
                         msg       = 'Checking for clang')

    if is_clang:
        if platform == 'darwin':
            compiler_name = 'clang-darwin'
        else:
            compiler_name = 'clang'
    elif conf.env['MSVC_COMPILER']:
            compiler_name = 'msvc'
    else:
        if platform == 'darwin':
            compiler_name = 'gcc-darwin'
        else:
            compiler_name = 'gcc'

    flags_dict = compiler_flags_dictionaries[compiler_name]
    # Save the compiler flags because we need them at build time
    # when we need to add compiler specific flags in certain
    # libraries
    conf.env['compiler_flags_dict'] = flags_dict;

    autowaf.set_basic_compiler_flags (conf,flags_dict)

    if conf.options.asan:
        conf.check_cxx(cxxflags=["-fsanitize=address", "-fno-omit-frame-pointer"], linkflags=["-fsanitize=address"])

=== gtk2_ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task
from waflib.Tools import winres
import subprocess
import glob

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'gtk2_ardour/'

gtk2_ardour_sources = [
        'about.cc',
        'actions.cc',
        'add_route_dialog.cc',
        'ambiguous_file_dialog.cc',
        'analysis_window.cc',
        'ardour_button.cc',
        'ardour_dialog.cc',
        'ardour_display.cc',
        'ardour_dropdown.cc',
        'ardour_knob.cc',
        'ardour_ui.cc',
        'ardour_ui2.cc',
        'ardour_ui_dependents.cc',
        'ardour_ui_dialogs.cc',
        'ardour_ui_ed.cc',
        'ardour_ui_mixer.cc',
        'ardour_ui_options.cc',
        'ardour_window.cc',
        'audio_clock.cc',
        'audio_region_editor.cc',
        'audio_region_view.cc',
        'audio_streamview.cc',
        'audio_time_axis.cc',
        'automation_controller.cc',
        'automation_line.cc',
        'automation_region_view.cc',
        'automation_streamview.cc',
        'automation_time_axis.cc',
        'axis_view.cc',
        'big_clock_window.cc',
        'bundle_manager.cc',
        'button_joiner.cc',
        'clock_group.cc',
        'configinfo.cc',
        'control_point.cc',
        'control_point_dialog.cc',
        'cursor_context.cc',
        'curvetest.cc',
        'debug.cc',
        'duplicate_routes_dialog.cc',
        'edit_note_dialog.cc',
        'editing.cc',
        'editor.cc',
        'editor_actions.cc',
        'editor_audio_import.cc',
        'editor_pt_import.cc',
        'editor_audiotrack.cc',
        'editor_canvas.cc',
        'editor_canvas_events.cc',
        'editor_component.cc',
        'editor_cursors.cc',
        'editor_drag.cc',
        'editor_route_groups.cc',
        'editor_export_audio.cc',
        'editor_group_tabs.cc',
        'editor_keys.cc',
        'editor_locations.cc',
        'editor_markers.cc',
        'editor_mixer.cc',
        'editor_mouse.cc',
        'editor_ops.cc',
        'editor_regions.cc',
        'editor_routes.cc',
        'editor_rulers.cc',
        'editor_selection.cc',
        'editor_snapshots.cc',
        'editor_summary.cc',
        'editor_tempodisplay.cc',
        'editor_timefx.cc',
        'engine_dialog.cc',
        'enums.cc',
        'export_channel_selector.cc',
        'export_dialog.cc',
        'export_file_notebook.cc',
        'export_filename_selector.cc',
        'export_format_dialog.cc',
        'export_format_selector.cc',
        'export_preset_selector.cc',
        'export_report.cc',
        'export_timespan_selector.cc',
        'fft.cc',
        'fft_graph.cc',
        'fft_result.cc',
        'floating_text_entry.cc',
        'sfdb_freesound_mootcher.cc',
        'gain_meter.cc',
        'generic_pluginui.cc',
        'ghostregion.cc',
        'global_port_matrix.cc',
        'group_tabs.cc',
        'gtk_pianokeyboard.c',
        'gui_object.cc',
        'insert_remove_time_dialog.cc',
        'instrument_selector.cc',
        'interthread_progress_window.cc',
        'io_selector.cc',
        'hit.cc',
        'keyboard.cc',
        'keyeditor.cc',
        'latency_gui.cc',
        'led.cc',
        'level_meter.cc',
        'location_ui.cc',
        'main.cc',
        'main_clock.cc',
        'marker.cc',
        'midi_automation_line.cc',
        'midi_channel_dialog.cc',
        'midi_channel_selector.cc',
        'midi_cut_buffer.cc',
        'midi_export_dialog.cc',
        'midi_list_editor.cc',
        'midi_port_dialog.cc',
        'midi_region_view.cc',
        'midi_scroomer.cc',
        'midi_selection.cc',
        'midi_streamview.cc',
        'midi_time_axis.cc',
        'midi_tracer.cc',
        'midi_velocity_dialog.cc',
        'missing_file_dialog.cc',
        'missing_plugin_dialog.cc',
        'mixer_actor.cc',
        'mixer_group_tabs.cc',
        'mixer_strip.cc',
        'mixer_ui.cc',
        'meterbridge.cc',
        'meter_strip.cc',
        'meter_patterns.cc',
        'monitor_section.cc',
        'monitor_selector.cc',
        'mono_panner.cc',
        'mono_panner_editor.cc',
        'mouse_cursors.cc',
        'nag.cc',
        'new_plugin_preset_dialog.cc',
        'normalize_dialog.cc',
        'note.cc',
        'note_base.cc',
        'note_player.cc',
        'note_select_dialog.cc',
        'nsm.cc',
        'nsmclient.cc',
        'option_editor.cc',
        'opts.cc',
        'panner2d.cc',
        'panner_editor.cc',
        'panner_interface.cc',
        'panner_ui.cc',
        'patch_change.cc',
        'piano_roll_header.cc',
        'pingback.cc',
        'playlist_selector.cc',
        'plugin_eq_gui.cc',
        'plugin_selector.cc',
        'plugin_ui.cc',
        'port_group.cc',
        'port_insert_ui.cc',
        'port_matrix.cc',
        'port_matrix_body.cc',
        'port_matrix_column_labels.cc',
        'port_matrix_component.cc',
        'port_matrix_grid.cc',
        'port_matrix_labels.cc',
        'port_matrix_row_labels.cc',
        'processor_box.cc',
        'patch_change_dialog.cc',
        'progress_reporter.cc',
        'prompter.cc',
        'public_editor.cc',
        'quantize_dialog.cc',
        'rc_option_editor.cc',
        'region_editor.cc',
        'region_gain_line.cc',
        'region_layering_order_editor.cc',
        'region_selection.cc',
        'region_view.cc',
        'return_ui.cc',
        'rhythm_ferret.cc',
        'route_group_dialog.cc',
        'route_group_menu.cc',
        'route_params_ui.cc',
        'route_processor_selection.cc',
        'route_time_axis.cc',
        'route_ui.cc',
        'ruler_dialog.cc',
        'save_as_dialog.cc',
        'search_path_option.cc',
        'selection.cc',
        'selection_memento.cc',
        'send_ui.cc',
        'session_dialog.cc',
        'session_import_dialog.cc',
        'session_metadata_dialog.cc',
        'session_option_editor.cc',
        'sfdb_ui.cc',
        'shuttle_control.cc',
        'soundcloud_export_selector.cc',
        'splash.cc',
        'speaker_dialog.cc',
        'startup.cc',
        'step_editor.cc',
        'step_entry.cc',
        'stereo_panner.cc',
        'stereo_panner_editor.cc',
        'streamview.cc',
        'strip_silence_dialog.cc',
        'sys_ex.cc',
        'tape_region_view.cc',
        'tempo_dialog.cc',
        'tempo_lines.cc',
        'theme_manager.cc',
        'time_axis_view.cc',
        'time_axis_view_item.cc',
        'time_fx_dialog.cc',
        'time_info_box.cc',
        'time_selection.cc',
        'timers.cc',
        'tooltips.cc',
        'track_selection.cc',
        'track_view_list.cc',
        'transform_dialog.cc',
        'transpose_dialog.cc',
        'ui_config.cc',
        'utils.cc',
        'verbose_cursor.cc',
        'visibility_group.cc',
        'window_manager.cc',
# video-timeline related sources:
        'video_image_frame.cc',
        'add_video_dialog.cc',
        'editor_videotimeline.cc',
        'video_timeline.cc',
        'video_monitor.cc',
        'transcode_ffmpeg.cc',
        'transcode_video_dialog.cc',
        'video_server_dialog.cc',
        'utils_videotl.cc',
        'export_video_dialog.cc',
        'export_video_infobox.cc',
        'video_tool_paths.cc'
]

def enoify (major, minor):
    # Code names based on
    # https://en.wikipedia.org/wiki/Brian_Eno_discography
    #
    # sort Studio albums + Collaborative albums + Compilation albums by Month/Year.
    # (no Singles, no EPs, no Video Albums, no Production)
    if major == 3:
        return "\\n\\\"E-No\\\""
    elif major == 4:
        if minor == 0:
            return "\\n\\\"No Pussyfooting\\\""
        elif minor == 1:
            return "\\n\\\"Here Come the Warm Jets\\\""
        elif minor == 2:
            return "\\n\\\"Taking Tiger Mountain\\\""
        elif minor == 3:
            return "\\n\\\"Lady June's Linguistic Leprosy\\\""
        elif minor == 4:
            return "\\n\\\"Discreet Music\\\""
        elif minor == 5:
            return "\\n\\\"Another Green World\\\""
        elif minor == 6:
            return "\\n\\\"Evening Star\\\""
        elif minor == 7:
            return "\\n\\\"Cluster and Eno\\\""
        elif minor == 8:
            return "\\n\\\"Before and After Science\\\""
    return "\\\"\\\""

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    # TODO: Insert a sanity check for on OS X to ensure CoreAudio is present

    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F',
                      mandatory=True)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW35F',
                      atleast_version='3.3.5', mandatory=False)
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD',
                      atleast_version='2.10.1')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'x11', uselib_store='X11', atleast_version='1.1', mandatory=False)
    autowaf.check_pkg(conf, 'fontconfig', uselib_store='FONTCONFIG')

    conf.write_config_header('gtk2ardour-config.h', remove=False)

    bak = conf.env['define_key']
    conf.define('VERSIONSTRING', str (conf.env['VERSION']))
    conf.define('CODENAME', enoify(int(conf.env['MAJOR']), int(conf.env['MINOR'])))
    conf.env['define_key'] = ['VERSIONSTRING', 'CODENAME' ]
    conf.write_config_header('gtk2ardour-version.h')
    conf.env['define_key'] = bak;

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

# Add a waf `feature' to allow compilation of things using winegcc
from waflib.TaskGen import feature
@feature("wine")
def set_winegcc(self):
    self.env.LINK_CXX = self.env.LINK_CC = 'wineg++'
    self.env.CC = 'winegcc'

def _doPyp(infileName, deps = False):
    outStr = ''
    out = []
    re_spaces = re.compile("\s+")

    if infileName == '-':
        fd = sys.stdin
    else:
        fd = open(infileName)
    inLines = fd.readlines()
    if fd != sys.stdin:
        fd.close()


    for line in inLines:
        bits = re_spaces.split(line)
        if bits[0] == '##include':
            incName = bits[1]
            if (deps):
                out += [ incName ]
            else:
                # assume included file comes from same place as source file
                incName = os.path.join (os.path.dirname (infileName), incName);
                outStr += _doPyp(incName)
        else:
            if not deps:
                outStr += line

    # done
    if deps:
        return out
    else:
        return outStr

def include_processor(task):
    infileName = task.inputs[0].srcpath()
    outfileName = os.path.join(out, task.outputs[0].bldpath())
    fdOut = open (outfileName, "w")
    fdOut.write (_doPyp(infileName))
    fdOut.close ()


def build_color_scheme(path, prefix):
    f = open (path, 'r')
    color_scheme = ''
    for line in f:
        if re.search ('^#@color', line):
            line.strip() # remove newline
            words = line.split()
            if len(color_scheme):
                color_scheme += ';'
            color_scheme += prefix
            color_scheme += '_'
            color_scheme += words[1]
            color_scheme += ':'
            color_scheme += words[2]
    f.close()
    return color_scheme

def build(bld):

=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys
import re
import subprocess
import sys

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 3001

I18N_PACKAGE = 'ardour'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'async_midi_port.cc',
        'audio_backend.cc',
        'audio_buffer.cc',
        'audio_diskstream.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'beats_frames_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'config_text.cc',
        'control_protocol_manager.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delayline.cc',
        'delivery.cc',
        'directory_names.cc',
        'diskstream.cc',
        'ebur128_analysis.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'engine_slave.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'gain_control.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'legatize.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_file_reader.cc',
        'ltc_slave.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_channel_filter.cc',
        'midi_clock_slave.cc',
        'midi_diskstream.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_scene_change.cc',
        'midi_scene_changer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'midiport_manager.cc',
        'mix.cc',
        'monitor_processor.cc',
        'mtc_slave.cc',
        'mididm.cc',
        'mtdm.cc',
        'mute_master.cc',
        'note_fixer.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_shell.cc',
        'parameter_descriptor.cc',
        'pcm_utils.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'port.cc',
        'port_insert.cc',
        'port_manager.cc',
        'port_set.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'recent_sessions.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_controls.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'scene_change.cc',
        'search_paths.cc',
        'send.cc',
        'session.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'slave.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'soundcloud_upload.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'srcfilesource.cc',
        'strip_silence.cc',
        'system_exec.cc',
        'revision.cc',
        'tape_file_matcher.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'transform.cc',
        'transpose.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    if Options.options.dist_target != 'mingw':
        if not Options.options.no_lrdf:
            autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                              atleast_version='0.4.0')
        autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                          atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')

    if Options.options.lv2:
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                          atleast_version='1.0.0', mandatory=True)
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_2_0',
                          atleast_version='1.2.0', mandatory=False)
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_10_0',
                          atleast_version='1.10.0', mandatory=False)
        autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                          atleast_version='0.8.0', mandatory=True)
        autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                          atleast_version='0.2.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_16_0',
                          atleast_version='0.16.0', mandatory=False)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_19_2',
                          atleast_version='0.19.2', mandatory=False)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV_0_21_3',
                          atleast_version='0.21.3', mandatory=False)
        autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                          atleast_version='0.6.0', mandatory=False)
        conf.define ('LV2_SUPPORT', 1)

#    autowaf.check_pkg(conf, 'soundtouch-1.0', uselib_store='SOUNDTOUCH',
#                      mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    # controls whether we actually use it in preference to soundtouch
    # Note: as of 2104, soundtouch (WSOLA) has been out-of-use for years.
    conf.define('USE_RUBBERBAND', 1)

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')
    if conf.env['WINDOWS_VST_SUPPORT'] == True and Options.options.dist_target == 'mingw':
        conf.check(compiler='cxx',
                   lib='gdi32',
                   mandatory=True,
                   uselib_store='GDI32')


def build(bld):
    # Library version (UNIX style major, minor, micro)
    # major increment <=> incompatible changes
    # minor increment <=> compatible changes (additions)
    # micro increment <=> no interface changes
    LIBARDOUR_LIB_VERSION = "3.0.0"

    # operate on copy to avoid adding sources twice
    sources = list(libardour_sources)
    if bld.is_tracks_build():
        sources += [ 'engine_state_controller.cc' ]

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=sources)
        # macros for this shared library
        obj.defines      = [ 'LIBARDOUR_DLL_EXPORTS=1' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=sources)
        obj.cxxflags     = [  bld.env['compiler_flags_dict']['pic'] ]
        obj.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = []

=== libs/audiographer/wscript ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
AUDIOGRAPHER_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
AUDIOGRAPHER_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'audiographer'
VERSION = AUDIOGRAPHER_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP', atleast_version='2.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2', mandatory=False)
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE', atleast_version='0.1.7', mandatory=False)
    autowaf.check_pkg(conf, 'sndfile', uselib_store='SNDFILE', atleast_version='1.0.18', mandatory=False)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW35F', atleast_version='3.3.5', mandatory=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/format.hpp')

def build(bld):

    # Headers
    #bld.install_files('${INCLUDEDIR}/audiographer', bld.path.ant_glob('audiographer/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/general', bld.path.ant_glob('audiographer/general/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/sndfile', bld.path.ant_glob('audiographer/sndfile/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/utils', bld.path.ant_glob('audiographer/utils/*.h'))

    #bld.env['BUILD_TESTS'] = True
    bld.env['HAVE_ALL_GTHREAD'] = (bld.is_defined('HAVE_GLIB')
                                   and bld.is_defined('HAVE_GLIBMM')
                                   and bld.is_defined('HAVE_GTHREAD'))

    if bld.is_defined('HAVE_FFTW35F') and bld.env['build_target'] != 'mingw':
        bld.env['LIB_FFTW3F'] += ['fftw3f_threads']

    audiographer_sources = [
        'private/gdither/gdither.cc',
        'src/general/sample_format_converter.cc',
        'src/routines.cc',
        'src/debug_utils.cc',
        'src/general/analyser.cc',
        'src/general/broadcast_info.cc',
        'src/general/normalizer.cc'
        ]
    if bld.is_defined('HAVE_SAMPLERATE'):
        audiographer_sources += [ 'src/general/sr_converter.cc' ]

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        audiographer              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=audiographer_sources)
        # macros for this shared library
        audiographer.defines      = [ 'LIBAUDIOGRAPHER_DLL_EXPORTS=1' ]
    else:
        audiographer              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=audiographer_sources)
        audiographer.cxxflags     = [ '-fPIC' ]
        audiographer.cflags       = [ '-fPIC' ]
        audiographer.defines      = []

    audiographer.name           = 'libaudiographer'
    audiographer.target         = 'audiographer'
    audiographer.export_includes = ['.', './src']
    audiographer.includes       = ['.', './src','../ardour','../timecode','../evoral']
    audiographer.uselib         = 'GLIB GLIBMM GTHREAD SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK'
    audiographer.use            = 'libpbd'
    audiographer.vnum           = AUDIOGRAPHER_LIB_VERSION
    audiographer.install_path   = bld.env['LIBDIR']


    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                tests/test_runner.cc
                tests/type_utils_test.cc
                tests/utils/identity_vertex_test.cc
                tests/general/interleaver_test.cc
                tests/general/deinterleaver_test.cc
                tests/general/interleaver_deinterleaver_test.cc
                tests/general/chunker_test.cc
                tests/general/sample_format_converter_test.cc
                tests/general/peak_reader_test.cc
                tests/general/normalizer_test.cc
                tests/general/silence_trimmer_test.cc
        '''

        if bld.is_defined('HAVE_ALL_GTHREAD'):
            obj.source += '''
                    tests/general/threader_test.cc
            '''

        if bld.is_defined('HAVE_SNDFILE'):
            obj.source += '''
                    tests/sndfile/tmp_file_test.cc
            '''

        if bld.is_defined('HAVE_SAMPLERATE'):
            obj.source += '''
                    tests/general/sr_converter_test.cc
            '''

        obj.use          = 'libaudiographer'
        obj.uselib       = 'CPPUNIT GLIBMM SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK'
        obj.target       = 'run-tests'
        obj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/gtkmm2ext/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '8'
MICRO = '3'
GTKMM2EXT_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
GTKMM2EXT_LIB_VERSION = '0.8.3'

# Variables for 'waf dist'
APPNAME = 'gtkmm2ext'
VERSION = GTKMM2EXT_VERSION
I18N_PACKAGE = 'gtkmm2ext3'

gtkmm2ext_sources = [
        'actions.cc',
        'application.cc',
        'ardour_icon.cc',
        'auto_spin.cc',
        'barcontroller.cc',
        'binding_proxy.cc',
        'bindable_button.cc',
        'bindings.cc',
        'cairocell.cc',
        'cairo_packer.cc',
        'cairo_widget.cc',
        'cell_renderer_color_selector.cc',
        'cell_renderer_pixbuf_multi.cc',
        'cell_renderer_pixbuf_toggle.cc',
        'choice.cc',
        'click_box.cc',
        'cursors.cc',
        'debug.cc',
        'dndtreeview.cc',
        'emscale.cc',
        'focus_entry.cc',
        'grouped_buttons.cc',
        'gtk_ui.cc',
        'gtkapplication.c',
        'idle_adjustment.cc',
        'keyboard.cc',
        'paths_dialog.cc',
        'persistent_tooltip.cc',
        'pixfader.cc',
        'pixscroller.cc',
        'popup.cc',
        'prompter.cc',
        'scroomer.cc',
        'selector.cc',
        'slider_controller.cc',
        'stateful_button.cc',
        'tearoff.cc',
        'textviewer.cc',
        'treeutils.cc',
        'utils.cc',
        'visibility_tracker.cc',
        'window_title.cc'
]

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/gtkmm2ext/'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM', atleast_version='2.8')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK', atleast_version='2.12.1')


def build(bld):
    # operate on copy to avoid adding sources twice
    sources = list(gtkmm2ext_sources)
    if bld.is_tracks_build():
        sources += [ 'waves_fastmeter.cc', 'fader.cc' ]
    else:
        sources += [ 'fastmeter.cc' ]

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=sources)
        # defines for this library
        obj.defines      = [ 'LIBGTKMM2EXT_DLL_EXPORTS', 'ABSTRACT_UI_EXPORTS' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=sources)
        obj.cxxflags     = [ '-fPIC' ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libgtkmm2ext'
    obj.target       = 'gtkmm2ext'
    obj.uselib       = 'GTKMM GTK GTKOSX OSX GDK'
    obj.use          = [ 'libpbd', 'libardour' ]
    obj.vnum         = GTKMM2EXT_LIB_VERSION
    obj.install_path = bld.env['LIBDIR']
    obj.defines     += [
                    'PACKAGE="' + I18N_PACKAGE + '"',
                    'LOCALEDIR="' + os.path.join(
                            os.path.normpath(bld.env['DATADIR']), 'locale') + '"']
    if bld.is_defined('GTKOSX'):
        obj.source += ['gtkapplication_quartz.mm']
    else:
        obj.source += ['gtkapplication_x11.c']

    # i18n
    if bld.is_defined('ENABLE_NLS'):
        mo_files = bld.path.ant_glob('po/*.mo')
        for mo in mo_files:
            lang = os.path.basename(mo.srcpath()).replace('.mo', '')
            bld.install_as (os.path.join(os.path.normpath(bld.env['LOCALEDIR']), lang, 'LC_MESSAGES', I18N_PACKAGE + '.mo'),
                            mo)

def i18n(bld):
    autowaf.build_i18n(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_pot(bld):
    autowaf.build_i18n_pot(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_po(bld):
    autowaf.build_i18n_po(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_mo(bld):
    autowaf.build_i18n_mo(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def shutdown():
    autowaf.shutdown()

=== libs/vamp-plugins/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBARDOURVAMPPLUGINS_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBARDOURVAMPPLUGINS_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libardourvampplugins'
VERSION = LIBARDOURVAMPPLUGINS_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    conf.write_config_header('libvampplugins-config.h', remove=False)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            plugins.cpp
            AmplitudeFollower.cpp
            EBUr128.cpp
            ebu_r128_proc.cc
            OnsetDetect.cpp
            PercussionOnsetDetector.cpp
            SpectralCentroid.cpp
            TruePeak.cpp
            ZeroCrossing.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libardourvampplugins'
    obj.target       = 'ardourvampplugins'
    obj.uselib       = 'FFTW3F VAMPSDK'
    obj.use          = 'libvampplugin libqmdsp'
    obj.defines      = [ 'ARDOUR_VAMP_PLUGINS_DLL_EPORTS' ]
    autowaf.ensure_visible_symbols (obj, True)
    if bld.is_defined('HAVE_AUBIO'):
        obj.source += ' Onset.cpp '
        obj.uselib += ' AUBIO '
    obj.vnum         = LIBARDOURVAMPPLUGINS_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'vamp')

def shutdown():
    autowaf.shutdown()

=== libs/backends/portaudio/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys
import re

I18N_PACKAGE = 'portaudio-backend'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'portaudio-2.0', uselib_store='PORTAUDIO', atleast_version='19')
    conf.check(header_name='pa_asio.h', define_name='WITH_ASIO', mandatory=False)

def build_portaudio (bld, name, defines):
    obj = bld(features = 'cxx cxxshlib')
    obj.source = [ 'portaudio_backend.cc',
                   'portaudio_io.cc',
                   'winmmemidi_io.cc',
                   'winmmemidi_input_device.cc',
                   'winmmemidi_output_device.cc',
                   'midi_util.cc',
                 ]
    obj.includes = ['.']
    obj.name     = name
    obj.target   = name
    obj.use      = 'libardour libpbd'
    obj.uselib   = ['PORTAUDIO']
    obj.install_path  = os.path.join(bld.env['LIBDIR'], 'backends')
    obj.defines = ['PACKAGE="' + I18N_PACKAGE + '"',
                   'ARDOURBACKEND_DLL_EXPORTS',
                   'USE_MMCSS_THREAD_PRIORITIES'
                  ]
    obj.defines += defines

def build(bld):
    build_portaudio (bld, 'portaudio_callback_backend', ['BACKEND_NAME="PortAudio (default)"'])

=== libs/surfaces/osc/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    autowaf.configure(conf)

def build(bld):
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            osc.cc
            osc_controllable.cc
            osc_route_observer.cc
            interface.cc
            osc_gui.cc
    '''
    obj.export_includes = ['.']
    obj.defines      = [ 'PACKAGE="ardour_osc"' ]
    obj.defines     += [ 'ARDOURSURFACE_DLL_EXPORTS' ]
    obj.includes     = ['.', './osc']
    obj.name         = 'libardour_osc'
    obj.target       = 'ardour_osc'
    obj.uselib       = 'LO GTKMM GTK GDK'
    obj.use          = 'libardour libardour_cp libgtkmm2ext libpbd'
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'surfaces')

def shutdown():
    autowaf.shutdown()

=== debian/changelog ===
ardour (1:4.7~dfsg-1mx150+1) mx; urgency=medium

  * Rebuild for MX-15.
  * Clean up formatting in long description.
  * debian/rules: comment out Jessie-incompatible -dbgsym file rule.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sun, 20 Mar 2016 19:37:44 -0700

ardour (1:4.7~dfsg-1) unstable; urgency=low

  * Imported Upstream version 4.7~dfsg

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Mon, 22 Feb 2016 21:53:30 +0100

=== debian/control ===
Source: ardour
Section: sound
Priority: optional
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends:
 cdbs,
 autotools-dev,
 devscripts,
 debhelper (>= 9~),
 dh-buildinfo,
 gettext,
 intltool,
 itstool,
 libboost-dev (>= 1.49.0),
 libcurl4-gnutls-dev (>= 7.25.0),
 libfftw3-dev (>= 3.3.1),
 liblrdf0-dev (>= 0.4.0),
 libserd-dev (>= 0.18.2~),
 libsord-dev (>= 0.12.0~),
 libsuil-dev (>= 0.6.10~),
 liblilv-dev,
 libsratom-dev (>= 0.4.2~),
 libsigc++-2.0-dev (>= 2.2.10),
 uuid-dev,
 libxml2-dev (>= 2.5.7),
 libcwiid-dev [linux-any],
 libcairomm-1.0-dev (>= 1.10.0),
 libgtkmm-2.4-dev (>= 2.24.2),
 libpangomm-1.4-dev (>= 2.28.4),
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4) [linux-any],
 libaubio-dev (>= 0.3.2),
 libjack-dev,
 liblo-dev (>= 0.26~),
 libltc-dev,
 librubberband-dev,
 libsamplerate0-dev (>= 0.1.8),
 libsndfile1-dev (>= 1.0.25),
 libtag1-dev,
 lv2-dev (>= 1.2.0),
 vamp-plugin-sdk (>=2.1),
 python-setuptools,
 python-isodate,
 python-rdflib
Standards-Version: 3.9.6
Homepage: http://www.ardour.org/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/ardour.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/ardour.git

Package: ardour
Architecture: any
Depends:
 ardour-data,
 ${cdbs:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Recommends:
 ${cdbs:Recommends}
Suggests:
 ${shlibs:Suggests}
Conflicts:
 ${cdbs:Conflicts}
Replaces:
 ardour3 (<< 1:3.5),
 ${cdbs:Replaces}
Breaks:
 ardour3 (<< 1:3.5)
Description: digital audio workstation
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces through the ALSA project, which provides
 high quality, well designed device drivers and API's for audio I/O under
 Linux. Any interface supported by ALSA can be used with Ardour. This includes
 the all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples using floating point internally,
 non-linear editing with unlimited undo, a user-configurable mixer, MTC
 master/slave capabilities, MIDI hardware control surface compatibility.
 .
 It supports MIDI Machine Control, and so can be controlled from any MMC
 controller and many modern digital mixers.
 .
 Ardour contains a powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing operations
 (insert, replace, delete, move, trim, select, cut/copy/paste). The editor has
 unlimited undo/redo capabilities and can save independent "versions" of a
 track or an entire piece.
 .
 Ardour's editor supports the community-developed LADSPA plugin standard.
 Arbitrary chains of plugins can be attached to any portion of a track. Every
 mixer strip can have any number of inputs and outputs, not just mono, stereo
 or 5.1.  An N-way panner is included, with support for various panning models.
 Pre- and post-fader sends exist, each with their own gain and pan controls.
 Every mixer strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another strip.
 .
 Ardour's channel capacity is limited only by the number on your audio interface
 and the ability of your disk subsystem to stream the data back and forth.
 .
 JACK (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications and/or
 hardware audio interfaces.
 .
 Ardour is sample rate and size neutral - any hardware formats from 8 to 32
 bits, and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be found at <http://ardour.org/>.

Package: ardour-data
Architecture: all
Depends: ${misc:Depends}
Recommends: ardour
Breaks: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Replaces: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Description: digital audio workstation (data)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This package contains the architecture-independent data files.


Package: ardour3
Architecture: all
Depends: ardour, ${misc:Depends}
Priority: extra
Section: oldlibs
Description: transitional dummy package for ardour
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a transitional dummy package. It can safely be removed.

Package: ardour-i686
Architecture: all
Depends: ardour, ${misc:Depends}
Priority: extra
Section: oldlibs
Description: transitional dummy package for (i686 optimized) ardour
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a transitional dummy package for the no-longer provided i686-optimized
 build of ardour. It can safely be removed.

Package: ardour-altivec
Architecture: all
Depends: ardour, ${misc:Depends}
Priority: extra
Section: oldlibs
Description: transitional dummy package for (altivec-optimized) ardour
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a transitional dummy package for the no-longer provided
 altivec-optimized build of ardour. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

# Path to the debian directory
empty =
DEBIAN_DIR := $(shell echo ${MAKEFILE_LIST} | awk '{print $$1}' | xargs dirname )
UPSTREAM_VERSION ?=$(shell uscan --dehs | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
DFSG = dfsg1
PKG = $(shell dpkg-parsechangelog -SSource)

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_CLEAN_EXCLUDE=debian/tmp
DEB_DESTDIR = $(CURDIR)/debian/tmp/

# ignore oddly packaged bzip2 archive to not upset dpkg
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(waf|(icons|gtk2_ardour)/icons/.*\.png|tools/osx_packaging/.*\.png|gtk_ardour/.*splash\.png|doc/ardour_meter_colors\.png|doc/layering/.*\.png|icons/made_with/ardour_made\.png|debian/(changelog|copyright(|_hints|_newhints)))$

# Set tag to full 40 char git tag for git snapshot release
tag = $(DEB_UPSTREAM_TARBALL_VERSION)
DEB_UPSTREAM_URL = https://github.com/Ardour/ardour/archive
DEB_UPSTREAM_TARBALL_BASENAME = $(tag)
DEB_UPSTREAM_TARBALL_SRCDIR = ardour-$(tag)

# Exclude these files from the Debian version
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./waf
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./.git*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVCvst_scan
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVCardour3
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/resource
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/msvc_resources.rc.in

waf-configure-options = --lv2 \
	--lxvst \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--no-phone-home \
	--use-external-libs \
	--optimize \
	--cxx11 \
	$(empty)


DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

BACKENDS = jack
ifneq (,$(findstring linux,$(DEB_HOST_ARCH_OS)))
	# ALSA Backend is only available on Linux
	BACKENDS = jack,alsa
else
	waf-configure-options += \
		--no-fpu-optimization \
		$(empty)
endif

LD_LIBRARY_PATH += :$(DEB_DESTDIR)/usr/lib/ardour4/

waf-configure-options += \
	--with-backends=$(BACKENDS) \
	--dist-target=$(DIST_TARGET) \
	$(empty)

DEB_MAKE_PARALLEL = -j$(if $(DEB_PARALLEL_JOBS),$(DEB_PARALLEL_JOBS),1)
DEB_MAKE_EXTRA_ARGS = -v --destdir=$(CURDIR)/debian/tmp $(DEB_MAKE_PARALLEL)
DEB_MAKE_BUILD_TARGET = build i18n_mo
DEB_MAKE_ENVVARS = CFLAGS="$(or $(CFLAGS_$(cdbs_curpkg)),$(CFLAGS))" CXXFLAGS="$(or $(CXXFLAGS_$(cdbs_curpkg)),$(CXXFLAGS))" CPPFLAGS="$(or $(CPPFLAGS_$(cdbs_curpkg)),$(CPPFLAGS))" LDFLAGS="$(or $(LDFLAGS_$(cdbs_curpkg)),$(LDFLAGS))"
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) $(CURDIR)/waf-light $(DEB_MAKE_EXTRA_ARGS)
DEB_MAKE_INSTALL_TARGET = install

## create -dbg package from the stripped info
#DEB_DH_STRIP_ARGS := --ddeb-migration='ardour-dbg (<< 1:4.6~dfsg-1)'

## ardour includes a couple of private lib*.so files, which make
## dh_makeshlibs emit a useless call to `ldconfig` in the postinst script.
## since we don't have any public libraries, we just suppress that call.
DEB_DH_MAKESHLIBS_ARGS_ardour := --noscripts

clean::
	rm -f autowaf.pyc
	rm -f .lock-wscript .lock-waf_linux2_build
	find waflib -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true
	rm -rf build
	rm -f \
		gtk2_ardour/version.cc\
		gtk2_ardour/version.h\
		gtk2_ardour/ardour.appdata.xml.in\
		libs/ardour/ardour/version.h\
		libs/ardour/config_text.cc\
		libs/ardour/svn_revision.cc\
		libs/ardour/version.cc\
		libs/gtkmm2ext/gtkmm2ext/version.h\
		libs/gtkmm2ext/version.cc\
		libs/midi++2/midi++/version.h\
		libs/midi++2/version.cc\
		libs/pbd/pbd/version.h\
		libs/pbd/version.cc\
		$(empty)
	rm -rf debian/tmp


common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: libs/ardour/revision.cc debian/stamp-waf-configure


libs/ardour/revision.cc:
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"${DEB_VERSION}\"; }" >> $@

debian/stamp-waf-configure:
	chmod +x ./waf-light
	$(DEB_MAKE_INVOKE) configure $(waf-configure-options)
	touch $@
clean::
	rm -f debian/stamp-waf-configure
	rm -f libs/ardour/revision.cc

# Needed at build time
# (separated in build tools, core, Glib/GTK and audio dependencies)
CDBS_BUILD_DEPENDS +=\
	, gettext\
	, intltool\
	, itstool\
	$(empty)
CDBS_BUILD_DEPENDS +=\
	, libboost-dev (>= 1.49.0),\
	, libcurl4-gnutls-dev (>= 7.25.0)\
	, libfftw3-dev (>= 3.3.1)\
	, liblrdf0-dev (>= 0.4.0), \
	, libserd-dev (>= 0.18.2~)\
	, libsord-dev (>= 0.12.0~)\
	, libsuil-dev (>= 0.6.10~)\
	, liblilv-dev\
	, libsratom-dev (>= 0.4.2~)\
	, libsigc++-2.0-dev (>= 2.2.10)\
	, uuid-dev\
	, libxml2-dev (>= 2.5.7)\
	, libcwiid-dev [linux-any]\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, libcairomm-1.0-dev (>= 1.10.0)\
	, libgtkmm-2.4-dev (>= 2.24.2)\
	, libpangomm-1.4-dev (>= 2.28.4)\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, ladspa-sdk (>= 1.1-2)\
	, libasound2-dev (>= 0.9.4) [linux-any]\
	, libaubio-dev (>= 0.3.2)\
	, libjack-dev\
	, liblo-dev (>= 0.26~)\
	, libltc-dev, \
	, librubberband-dev, \
	, libsamplerate0-dev (>= 0.1.8)\
	, libsndfile1-dev (>= 1.0.25)\
	, libtag1-dev, \
	, lv2-dev (>= 1.2.0)\
	, vamp-plugin-sdk (>=2.1)\
	, $(empty)
CDBS_BUILD_DEPENDS +=\
	, python-setuptools\
	, python-isodate\
	, python-rdflib\
	, $(empty)

# Needed always/often/sometimes at runtime
CDBS_DEPENDS_ALL = jackd
CDBS_RECOMMENDS_ALL = iceweasel | www-browser
CDBS_SUGGESTS_ALL = jamin, qjackctl

# Ensure only one variant is installed at a time
CDBS_PROVIDES_ardour-altivec = ardour
CDBS_PROVIDES_ardour-i686 = ardour

# Quirk for derivatives using different packaging name
ifeq (Ubuntu,$(shell dpkg-vendor --query Vendor))
CDBS_RECOMMENDS_ALL = firefox | www-browser
endif

DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./waf
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./.git*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./MSVC**
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./msvc*
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./icons/win32/**
